VERSION 5.00
Object = "{F9043C88-F6F2-101A-A3C9-08002B2F49FB}#1.2#0"; "COMDLG32.OCX"
Begin VB.Form EphemDB 
   Caption         =   "EphemDB"
   ClientHeight    =   285
   ClientLeft      =   60
   ClientTop       =   630
   ClientWidth     =   8430
   BeginProperty Font 
      Name            =   "Courier New"
      Size            =   9
      Charset         =   0
      Weight          =   700
      Underline       =   0   'False
      Italic          =   -1  'True
      Strikethrough   =   0   'False
   EndProperty
   ForeColor       =   &H80000008&
   Icon            =   "EphemDB.frx":0000
   LinkTopic       =   "Form1"
   PaletteMode     =   1  'UseZOrder
   ScaleHeight     =   285
   ScaleWidth      =   8430
   Begin MSComDlg.CommonDialog DLog 
      Left            =   3960
      Top             =   0
      _ExtentX        =   847
      _ExtentY        =   847
      _Version        =   393216
   End
   Begin VB.Timer Timer1 
      Interval        =   1000
      Left            =   3360
      Top             =   0
   End
   Begin VB.Menu mnuFile 
      Caption         =   "&File"
      Begin VB.Menu mnuFileNewFil 
         Caption         =   "&Make new .FIL file"
      End
      Begin VB.Menu mnuFileExit 
         Caption         =   "E&xit"
         Shortcut        =   {F12}
      End
   End
   Begin VB.Menu mnuInputData 
      Caption         =   "&Input"
      Visible         =   0   'False
   End
   Begin VB.Menu mnuData 
      Caption         =   "&Data"
      Visible         =   0   'False
      Begin VB.Menu mnuDataNatalData 
         Caption         =   "&Natal Data"
         Shortcut        =   {F2}
      End
      Begin VB.Menu mnuSplit62 
         Caption         =   "-"
      End
      Begin VB.Menu mnuDataTransitData 
         Caption         =   "&Transit Data"
         Shortcut        =   {F3}
      End
      Begin VB.Menu mnuSplit69 
         Caption         =   "-"
      End
      Begin VB.Menu mnuDataEphemeris 
         Caption         =   "Generate &Ephemeris data"
         Shortcut        =   {F4}
      End
      Begin VB.Menu mnuSplit73 
         Caption         =   "-"
      End
      Begin VB.Menu mnuDataAspectarian 
         Caption         =   "&Aspectarian (Transit to Natal)"
         Shortcut        =   {F8}
      End
      Begin VB.Menu mnuDataAspectarianTT 
         Caption         =   "As&pectarian (Transit to Transit)"
         Shortcut        =   {F9}
      End
      Begin VB.Menu mnuSplit68a 
         Caption         =   "-"
      End
      Begin VB.Menu mnuDeleteEphemeris 
         Caption         =   "Delete all records in Ephemeris db"
      End
      Begin VB.Menu mnuDeleteTN 
         Caption         =   "Delete all records in T-N db"
      End
      Begin VB.Menu mnuDeleteTT 
         Caption         =   "Delete all records in T-T db"
      End
      Begin VB.Menu mnuSplit72 
         Caption         =   "-"
      End
      Begin VB.Menu mnuDataViewEphemeris 
         Caption         =   "&View Ephemeris DB"
         Shortcut        =   {F5}
      End
      Begin VB.Menu mnuDataViewTN 
         Caption         =   "&View Transit to Natal DB"
         Shortcut        =   {F6}
      End
      Begin VB.Menu mnuDataViewTT 
         Caption         =   "Vie&w Transit to Transit DB"
         Shortcut        =   {F7}
      End
   End
   Begin VB.Menu mnuOptions 
      Caption         =   "&Options"
      Begin VB.Menu mnuOptionOptionSettings 
         Caption         =   "&Option Settings"
         Shortcut        =   ^{F9}
      End
   End
   Begin VB.Menu mnuHelp 
      Caption         =   "&Help"
      Begin VB.Menu mnuHelpEphemDB 
         Caption         =   "&EphemDB Window"
         Begin VB.Menu mnuMainMenuHelp 
            Caption         =   "&EphemDB Main Menu"
            Shortcut        =   {F1}
         End
      End
      Begin VB.Menu mnuSplit0 
         Caption         =   "-"
      End
      Begin VB.Menu mnuHelpInputD 
         Caption         =   "Natal &Input Data Window"
      End
      Begin VB.Menu mnuHelpInputD1 
         Caption         =   "&Diurnal Input Data Window"
      End
      Begin VB.Menu mnuHelpNames 
         Caption         =   "&Names Window"
      End
      Begin VB.Menu mnuHelpCities 
         Caption         =   "Cities &Window"
      End
      Begin VB.Menu mnuHelpOptions 
         Caption         =   "&Options Window"
      End
      Begin VB.Menu mnuHelpOutputD1 
         Caption         =   "Da&ta Window"
      End
      Begin VB.Menu mnuHelpNameedit 
         Caption         =   "&Edit A Name File Window"
      End
      Begin VB.Menu mnuHelpLongLat 
         Caption         =   "Edit A Cit&y File Window"
      End
      Begin VB.Menu mnuHelpSelect 
         Caption         =   "&Select A File Window"
      End
      Begin VB.Menu mnuHelpPrntfile 
         Caption         =   "&File To Print  Window"
      End
      Begin VB.Menu mnuSplit1 
         Caption         =   "-"
      End
      Begin VB.Menu mnuHelpHints 
         Caption         =   "&Hints"
         Begin VB.Menu mnuHintsHow 
            Caption         =   "&How Do I...?"
            Shortcut        =   ^H
         End
         Begin VB.Menu mnuHintsReadingList 
            Caption         =   "&Reading List"
            Shortcut        =   ^R
         End
         Begin VB.Menu mnuHintsTips 
            Caption         =   "&Tips"
         End
      End
      Begin VB.Menu mnuShortcutKeys 
         Caption         =   "Shortcut &Keys"
      End
      Begin VB.Menu mnuHelpLicense 
         Caption         =   "&License Agreement"
      End
      Begin VB.Menu mnuSplit2 
         Caption         =   "-"
      End
      Begin VB.Menu mnuHelpRevisions 
         Caption         =   "Re&vision History"
      End
      Begin VB.Menu mnuHelpAbout 
         Caption         =   "Abo&ut"
      End
   End
End
Attribute VB_Name = "EphemDB"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False

Private Sub Form_Load()
    Dim Fetch As String, X%, xx%, z&

    Randomize Timer

    DefaultDirectory = App.path
    swe_set_ephe_path (App.path):   'set path to ephemeris files

    If App.PrevInstance Then
        MsgBox "EphemDB is already running. For your protection you cannot have more than one copy of EphemDB running at a time.", 16, "WARNING!"
        End
    End If

    AddFontResource DefaultDirectory$ & "\" & "EphemDB.ttf"

    Call GetOptions: Call GetXCaption
    crlf = Chr$(13) + Chr$(10)

    splash% = 0
    Load TITLE

    TITLE!cmdOK.Visible = True
ssc1q:
    If splash% = 0 Then
        DoEvents
        GoTo ssc1q
    End If

    Screen.MousePointer = 11
    MasterFontName = "COURIER NEW"

    Call INI_GetSettings
    Call INI_GetSettings_WIN_INI

    OrigFontSize = FontSize: OrigFontName$ = FontName

    XResolution% = Screen.Width / Screen.TwipsPerPixelX

    LineCounter& = 0: fetch_ss% = 0
    NichtProcess% = 0: LockList% = 0: NoNo% = 0

    If XResolution% = 640 Then
        MasterScaleWidth = 640: MasterScaleHeight = 480
        MasterWidth = 8490: '8105 (Because Smaller-Larger was taken out of Wheels menu)
        MasterHeight = 7200: PlanetScaling = 1.5
    ElseIf XResolution% = 800 Then
        MasterScaleWidth = 800: MasterScaleHeight = 600
        MasterWidth = 10725: '10700 (Because Smaller-Larger was taken out of Wheels menu)
        MasterHeight = 8940: PlanetScaling = 1.5
        If Screen.TwipsPerPixelX = 12 Then
            MasterWidth = 8400: '(Because Smaller-Larger was taken out of Wheels menu)
            MasterHeight = 7200: PlanetScaling = 1.2
        End If
    Else
        MasterScaleWidth = 1024: MasterScaleHeight = 768
        MasterWidth = 10970: '10945 (Because Smaller-Larger was taken out of Wheels menu)
        MasterHeight = 9204: PlanetScaling = 1.2
        If Screen.TwipsPerPixelX = 15 Then
            MasterWidth = 14050: '13965 (Because Smaller-Larger was taken out of Wheels menu)
            MasterHeight = 11505: PlanetScaling = 1.5
        End If
    End If

    CurrentOrbsFile$ = DefaultDirectory$ & "\NATAL.ORB"
    OutputNameFile = "": PI = 3.1415926535

    NumberOfPlanets% = 16

    ReDim Planets(NumberOfPlanets%)
    ReDim DECL(NumberOfPlanets%), PN$(NumberOfPlanets%)
    ReDim SpeedX(NumberOfPlanets%)
    ReDim Natal(NumberOfPlanets%), NatalDecl(NumberOfPlanets%)
    ReDim Transit(NumberOfPlanets%), TransitDecl(NumberOfPlanets%)
    ReDim MPNames$(NumberOfPlanets%)

    AU = 149597870:  'AU in Km

    PX1$ = "SUN       MOON      MERCURY   VENUS     MARS      JUPITER   SATURN    URANUS    NEPTUNE   "
    SX1$ = "PLUTO     N. NODE   S. NODE   Part F.   ASC       MC        CHIRON    "
    PX1$ = PX1$ + SX1$

    SX1$ = "ARITAUGEMCANLEOVIRLIBSCOSAGCPRAQUPIS"
    HCX1$ = "10TH11TH12TH 1ST 2ND 3RD 4TH 5TH 6TH 7TH 8TH 9TH    "

    AAX1$ = "            conjunct    sextile     square      trine       "
    AAX1$ = AAX1$ + "opposite    PARALLEL    s.sextile   s.square    ses.square  "
    AAX1$ = AAX1$ + "quincunx    s.quintile  nonagen     quintile    trecile     "
    AAX1$ = AAX1$ + "bi-quintile "

    PN$(1) = "SUN": PN$(2) = "MOON": PN$(3) = "MERCURY": PN$(4) = "VENUS"
    PN$(5) = "MARS": PN$(6) = "JUPITER": PN$(7) = "SATURN"
    PN$(8) = "URANUS": PN$(9) = "NEPTUNE": PN$(10) = "PLUTO"
    PN$(11) = "N. NODE": PN$(12) = "S. NODE":
    PN$(13) = "Part F.": PN$(14) = "ASC": PN$(15) = "MC ": PN$(16) = "CHIRON "

    ASPECTS%(2) = 0: ASPECTS%(3) = 60: ASPECTS%(4) = 90: ASPECTS%(5) = 120
    ASPECTS%(6) = 180: ASPECTS%(7) = 0: ASPECTS%(8) = 30: ASPECTS%(9) = 45
    ASPECTS%(10) = 135: ASPECTS%(11) = 150: ASPECTS%(12) = 36: ASPECTS%(13) = 40
    ASPECTS%(14) = 72: ASPECTS%(15) = 108: ASPECTS%(16) = 144: ASPECTS%(17) = 51

    Retrograde$ = Space$(NumberOfPlanets%)
    ph$ = Space$(130) + "---- --------- -----"
    If NumberOfPlanets% > 15 Then
        ph$ = ph$ & Space((NumberOfPlanets% - 15) * 10)
    End If

    MPNames$(1) = "Sun": MPNames$(2) = "Moon": MPNames$(3) = "Mercury"
    MPNames$(4) = "Venus": MPNames$(5) = "Mars": MPNames$(6) = "Jupiter"
    MPNames$(7) = "Saturn": MPNames$(8) = "Uranus": MPNames$(9) = "Neptune"
    MPNames$(10) = "Pluto": MPNames$(11) = "N_Node": MPNames$(12) = "S_Node"
    MPNames$(13) = "P_of_F": MPNames$(14) = "Asc": MPNames$(15) = "M_Heaven": MPNames$(16) = "Chiron"

    Me.Show
    NichtProcess% = 1
    InputD.Show: InputD1.Show
    Names.SetFocus

    Screen.MousePointer = 0

    On Error Resume Next
    MkDir DefaultDirectory & "\REPORTS"
    MkDir DefaultDirectory & "\N_REPORT"
    On Error GoTo 0
End Sub

Private Sub Form_Unload(Cancel As Integer)
    mnuFileExit_Click
End Sub

Private Sub mnuDataAspectarian_Click()
    TN_or_TT% = 0
    Call CalcAspectarian
End Sub

Private Sub mnuDataAspectarianTT_Click()
    TN_or_TT% = 1
    Call CalcAspectarian
End Sub


Private Sub mnuDataEphemeris_Click()
    TN_or_TT% = 2
    Call CalcAspectarian
End Sub


Private Sub mnuDataNatalData_Click()
    Call XHeader1
    Call NatalList
    Call AdjustForm
End Sub

Private Sub mnuDataTransitData_Click()
    Call ClearOutputForm
    Call TransitList
    Call AdjustForm
    XSTEP% = 0
End Sub

Private Sub mnuDataViewEphemeris_Click()
    Unload frmDisplayEphem: Load frmDisplayEphem
End Sub

Private Sub mnuDataViewTN_Click()
    Unload frmDisplayDB: Load frmDisplayDB
End Sub

Private Sub mnuDataViewTT_Click()
    Unload frmDisplayDB_TT: Load frmDisplayDB_TT
End Sub


Private Sub mnuDeleteEphemeris_Click()
    Screen.MousePointer = 11

    db_code% = 77
    Call OpenDB
    Call DeleteAllRecords

    Screen.MousePointer = 0
End Sub

Private Sub mnuDeleteTN_Click()
    Screen.MousePointer = 11

    db_code% = 99
    Call OpenDB
    Call DeleteAllRecords

    Screen.MousePointer = 0
End Sub

Private Sub mnuDeleteTT_Click()
    Screen.MousePointer = 11

    db_code% = 88
    Call OpenDB
    Call DeleteAllRecords

    Screen.MousePointer = 0
End Sub


Private Sub mnuFileExit_Click()
    RemoveFontResource DefaultDirectory$ & "\" & "EphemDB.ttf"

    Call INI_SaveSettings

    If OrigFontSize < 8 Then
        FontSize = OrigFontSize
    End If
    FontName = OrigFontName$: FontSize = OrigFontSize
    Set EphemDB = Nothing
    End
End Sub

Private Sub mnuFileNewFil_Click()
    Dim X%

    EphemDB!Dlog.CancelError = True
    EphemDB!Dlog.DefaultExt = "fil"
    EphemDB!Dlog.InitDir = DefaultDirectory$
    EphemDB!Dlog.filename = "NEW.FIL"
    EphemDB!Dlog.Filter = "Data Files (*.FIL) | *.FIL"
    EphemDB!Dlog.FilterIndex = 1
    EphemDB!Dlog.Flags = OFN_OVERWRITEPROMPT Or OFN_PATHMUSTEXIST
    On Error GoTo PVC33a
    EphemDB!Dlog.Action = 2
    OutputNameFile = EphemDB!Dlog.filename

    Close #1
    Open OutputNameFile For Output As #1
    Print #1, "Example" & "," & "12 May 1959" & "," & "10.43" & "," & "A" & "," & "6" & "," & "75.23" & "," & "39.45" & "," & "userID@email.com"
PVC44a:
    Close #1
    Exit Sub

PVC33a:  Resume PVC44a
End Sub

Private Sub mnuHelpAbout_Click()
    About.Show
End Sub

Private Sub mnuHelpCities_Click()
    CurrentHelpFile$ = "\GEOGRAPH.HLP"
    Call DisplayHelp
End Sub

Private Sub mnuHelpInputD_Click()
    CurrentHelpFile$ = "\INPUTD.HLP"
    Call DisplayHelp
End Sub

Private Sub mnuHelpInputD1_Click()
    CurrentHelpFile$ = "\INPUTD1.HLP"
    Call DisplayHelp
End Sub

Private Sub mnuHelpLicense_Click()
    CurrentHelpFile$ = "\LICENSE.HLP"
    Call DisplayHelp
End Sub

Private Sub mnuHelpLongLat_Click()
    CurrentHelpFile$ = "\LONGLAT.HLP"
    Call DisplayHelp
End Sub

Private Sub mnuHelpNameedit_Click()
    CurrentHelpFile$ = "\NAMEEDIT.HLP"
    Call DisplayHelp
End Sub

Private Sub mnuHelpNames_Click()
    CurrentHelpFile$ = "\NAMES.HLP"
    Call DisplayHelp
End Sub

Private Sub mnuHelpOptions_Click()
    CurrentHelpFile$ = "\OPTIONS.HLP"
    Call DisplayHelp
End Sub

Private Sub mnuHelpOutputD1_Click()
    CurrentHelpFile$ = "\OUTPUTD1.HLP"
    Call DisplayHelp
End Sub

Private Sub mnuHelpPrntfile_Click()
    CurrentHelpFile$ = "\PRNTFILE.HLP"
    Call DisplayHelp
End Sub

Private Sub mnuHelpRevisions_Click()
    CurrentHelpFile$ = "\REVISION.HLP"
    Call DisplayHelp
End Sub

Private Sub mnuHelpSelect_Click()
    CurrentHelpFile$ = "\SELECT.HLP"
    Call DisplayHelp
End Sub


Private Sub mnuHintsHow_Click()
    CurrentHelpFile$ = "\HOW_DO_I.HLP"
    Call DisplayHelp
End Sub

Private Sub mnuHintsReadingList_Click()
    CurrentHelpFile$ = "\READING.HLP"
    Call DisplayHelp
End Sub

Private Sub mnuHintsTips_Click()
    CurrentHelpFile$ = "\TIPS.HLP"
    Call DisplayHelp
End Sub

Private Sub mnuInputData_Click()
    LineCounter& = 0
    If ZN$ <> "Now" Then NichtProcess% = 0
    OutputNameFile = ""
    NatOrTranOuter% = 0

    Unload OutputD1
    InputD.Show: InputD1.Show: Unload Names: Load Names: Names.Show
    If InputD!txtName.Text = "Now" Then
        InputD!txtMonth.Text = Format$(Now, "m")
        InputD!txtDay.Text = Format$(Now, "d")
        InputD!txtYear.Text = Format$(Now, "yyyy")

        InputD!txtBirthHour.Text = Format$(Now, "h")
        InputD!txtBirthMinute.Text = Format$(Now, "n")

        InputD!optAM = True
        If MyiTime% = 1 Then
            If Val(Format$(Now, "h")) >= 12 Then InputD!optPM = True
        Else
            If UCase$(Right$(Now, 2)) = "PM" Then InputD!optPM = True
        End If
    End If
End Sub

Private Sub mnuMainMenuHelp_Click()
    CurrentHelpFile$ = "\EphemDB.HLP"
    Call DisplayHelp
End Sub

Private Sub mnuOptionOptionSettings_Click()
    On Error GoTo OPA1
    Open DefaultDirectory + "\OPTIONS.OPT" For Input As #1
    Close #1
    Options.Show
    Exit Sub

OPA1:
    MsgBox "File Not Found", 64, "Warning!"
    Exit Sub
End Sub

Private Sub mnuShortcutKeys_Click()
    CurrentHelpFile$ = "\SHORTCUT.HLP"
    Call DisplayHelp
End Sub

Private Sub Timer1_Timer()
    EphemDB.Caption = XCaption$ & Format$(Date, "dd mmm yyyy") & Space(5) & time
End Sub

